define([
	"dojo/_base/kernel", // dojo.config.blankGif
	"dojo/_base/html", // dojo.addClass dojo.create dojo.getComputedStyle
	"dojo/ready", // dojo.ready
	"dojo/_base/sniff", // dojo.isIE dojo.isMoz
	"dojo/_base/url", // dojo.moduleUrl
	"dojo/_base/window" // dojo.body
], function(dojo){

	// module:
	//		dijit/hccss
	// summary:
	//		Test if computer is in high contrast mode, and sets dijit_a11y flag on <body> if it is.

	if(dojo.isIE || dojo.isMoz){	// NOTE: checking in Safari messes things up
		// priority is 90 to run ahead of parser priority of 100
		dojo.ready(90, function(){
			// summary:
			//		Detects if we are in high-contrast mode or not

			// create div for testing if high contrast mode is on or images are turned off
			var div = dojo.create("div",{
				id: "a11yTestNode",
				style:{
					cssText:'border: 1px solid;'
						+ 'border-color:red green;'
						+ 'position: absolute;'
						+ 'height: 5px;'
						+ 'top: -999px;'
						+ 'background-image: url("' + (dojo.config.blankGif || dojo.moduleUrl("dojo", "resources/blank.gif")) + '");'
				}
			}, dojo.body());

			// test it
			var cs = dojo.getComputedStyle(div);
			if(cs){
				var bkImg = cs.backgroundImage;
				var needsA11y = (cs.borderTopColor == cs.borderRightColor) || (bkImg != null && (bkImg == "none" || bkImg == "url(invalid-url:)" ));
				if(needsA11y){
					dojo.addClass(dojo.body(), "dijit_a11y");
				}
				if(dojo.isIE){
					div.outerHTML = "";		// prevent mixed-content warning, see http://support.microsoft.com/kb/925014
				}else{
					dojo.body().removeChild(div);
				}
			}
		});
	}
});
